SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'actors' stamp: 'GrossodelSel 5/16/2012 19:50'!
blueGhost

	^BlueGhost new! !

!PacManTest methodsFor: 'actors' stamp: 'GrossodelSel 5/19/2012 17:44'!
blueberry

	^Blueberry new. ! !

!PacManTest methodsFor: 'movements' stamp: 'GrossodelSel 5/16/2012 21:09'!
down

	^0@(-1).! !

!PacManTest methodsFor: 'construction block types' stamp: 'GrossodelSel 5/16/2012 21:14'!
ghostHouseDoorType

	^GhostHouseDoorType.! !

!PacManTest methodsFor: 'movements' stamp: 'GrossodelSel 5/16/2012 21:09'!
left

	^-1@0.! !

!PacManTest methodsFor: 'construction block types' stamp: 'GrossodelSel 5/16/2012 21:14'!
leftTransporterType

	^LeftTransporterType.! !

!PacManTest methodsFor: 'actors' stamp: 'GrossodelSel 5/16/2012 19:59'!
pacman

	^PacMan new! !

!PacManTest methodsFor: 'movements' stamp: 'GrossodelSel 5/16/2012 21:09'!
right

	 ^1@0.! !

!PacManTest methodsFor: 'construction block types' stamp: 'GrossodelSel 5/16/2012 21:14'!
spaceType

	^SpaceType.
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:38'!
test02aFruitCanNotGoIntoAWall

	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self left ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self right ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self up ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:39'!
test04aFruitMovesIntoSpaces

	self assert: ( self blueberry position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self left ).
	self assert: ( self blueberry position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:40'!
test06aFruitCanEnterHisHouse

	self assert: ( self blueberry position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self left).
	self assert: ( self blueberry position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:46'!
test09TransporterMovesFruitToNewPosition

	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self left ).
	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'GrossodelSel 5/16/2012 21:09'!
up

	 ^0@1.! !

!PacManTest methodsFor: 'construction block types' stamp: 'GrossodelSel 5/16/2012 21:14'!
wallType

	^WallType.! !

Object subclass: #Actor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Actor methodsFor: 'physics' stamp: 'GrossodelSel 5/16/2012 21:05'!
nextPositionThrough:aBlockType going:aDirection

	self subclassResponsibility.! !

!Actor methodsFor: 'physics' stamp: 'GrossodelSel 5/19/2012 17:48'!
position

	self subclassResponsibility.! !

Actor subclass: #BlueGhost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!BlueGhost methodsFor: 'physics' stamp: 'GrossodelSel 5/19/2012 17:50'!
nextPositionThrough:aBlockType going:aDirection

	^aBlockType nextPositionForBlueGhost:self going:aDirection.! !

!BlueGhost methodsFor: 'physics' stamp: 'GrossodelSel 5/16/2012 21:05'!
position

	^0@0! !

Actor subclass: #Blueberry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Blueberry methodsFor: 'physics' stamp: 'GrossodelSel 5/19/2012 17:50'!
nextPositionThrough:aBlockType going:aDirection

	^aBlockType nextPositionForBlueberry:self going:aDirection.! !

!Blueberry methodsFor: 'physics' stamp: 'GrossodelSel 5/19/2012 17:49'!
position

	^0@0.! !

Actor subclass: #PacMan
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacMan methodsFor: 'physics' stamp: 'GrossodelSel 5/16/2012 21:05'!
nextPositionThrough:aBlockType going:aDirection

	^aBlockType nextPositionForPacMan:self going:aDirection.! !

!PacMan methodsFor: 'physics' stamp: 'GrossodelSel 5/19/2012 17:52'!
position

	^0@0! !

Object subclass: #BlockType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!BlockType class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/16/2012 21:10'!
nextPositionFor:actor going:direction

	self subclassResponsibility! !

BlockType subclass: #InteractiveBlockType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

InteractiveBlockType subclass: #GhostHouseDoorType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostHouseDoorType class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/16/2012 21:12'!
nextPositionForBlueGhost:aBlueGhost going:aDirection

	^aBlueGhost position + aDirection! !

!GhostHouseDoorType class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/19/2012 17:57'!
nextPositionForBlueberry: aBlueberry going: aPoint

	^aBlueberry position + aPoint.! !

!GhostHouseDoorType class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/16/2012 21:12'!
nextPositionForPacMan:aPacMan going:aDirection

	^aPacMan position.! !

!InteractiveBlockType class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/19/2012 18:09'!
nextPositionFor:actor going:direction

	^actor nextPositionThrough:self going:direction.! !

!InteractiveBlockType class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/16/2012 21:11'!
nextPositionForBlueGhost:aBlueGhost going:aDirection

	self subclassResponsibility.! !

!InteractiveBlockType class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/19/2012 18:16'!
nextPositionForBlueberry: aBlueberry going: aPoint

	self subclassResponsibility.! !

!InteractiveBlockType class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/16/2012 21:11'!
nextPositionForPacMan:aBlueGhost going:aDirection

	self subclassResponsibility.! !

InteractiveBlockType subclass: #LeftTransporterType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!LeftTransporterType class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/16/2012 21:13'!
nextPositionForBlueGhost:aBlueGhost going:aDirection

	^aBlueGhost position! !

!LeftTransporterType class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/19/2012 17:58'!
nextPositionForBlueberry: aBlueberry going: aPoint

	^5@10.! !

!LeftTransporterType class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/16/2012 21:13'!
nextPositionForPacMan:aPacMan going:aDirection

	^3@10.! !

BlockType subclass: #SpaceType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!SpaceType class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/16/2012 21:13'!
nextPositionFor:actor going:direction

	^actor position + direction! !

BlockType subclass: #WallType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!WallType class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 5/16/2012 21:13'!
nextPositionFor:actor going:direction

	^actor position! !
